## ros-indigo-ueye 0.0.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ueye)

set(${PROJECT_NAME}_CATKIN_DEPS
  roscpp
  roslib
  nodelet
  dynamic_reconfigure
  image_transport
  camera_calibration_parsers
)

find_package(catkin REQUIRED COMPONENTS ${${PROJECT_NAME}_CATKIN_DEPS})

set(${PROJECT_NAME}_INCLUDE_EXPORTS
  include
)

generate_dynamic_reconfigure_options(cfg/mono.cfg cfg/stereo.cfg)

catkin_package(
  INCLUDE_DIRS ${${PROJECT_NAME}_INCLUDE_EXPORTS}
  LIBRARIES ueye_nodelets
  CATKIN_DEPENDS ${${PROJECT_NAME}_CATKIN_DEPS}
)

include_directories(
  ${catkin_INCLUDE_DIRS}
  ${${PROJECT_NAME}_INCLUDE_EXPORTS}
)

# Check for installed uEye SDK
include(CheckIncludeFileCXX)
check_include_file_cxx("ueye.h" HAVE_UEYE_H)
if (NOT HAVE_UEYE_H)
  include(TargetArch.cmake)
  target_architecture(TARGET_ARCH)
  message("-- uEye SDK not found. Using downloaded files for '${TARGET_ARCH}' architecture. (~2MB)")
  message("-- This method is only intended for the buildfarm, and will fail to communicate if the official uEye SDK is not installed.")
  message("-- The official uEye SDK can be found at https://en.ids-imaging.com/download-ueye.html (~70MB)")

  if (TARGET_ARCH STREQUAL "amd64")
    message("-- The official uEye SDK for amd64: https://en.ids-imaging.com/download-ueye.html?file=tl_files/downloads/uEye_SDK/driver/uEye_Linux_4.60_64_Bit.zip (~71MB)")
    file(DOWNLOAD 
      #https://bitbucket.org/kmhallen/ueye/downloads/uEye_SDK_4_60_amd64.tar.gz
      http://download.ros.org/data/ueye/uEye_SDK_4_60_amd64.tar.gz
      ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/uEye_SDK_amd64.tar.gz
      SHOW_PROGRESS
      INACTIVITY_TIMEOUT 60
      EXPECTED_MD5 e56ede9549b84e9093a1d3b4b9ff9344
      TLS_VERIFY on)
    execute_process(
      COMMAND ${CMAKE_COMMAND} -E tar xzf ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/uEye_SDK_amd64.tar.gz
      WORKING_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty
    )
    include_directories(${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/amd64)
    link_directories(${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/amd64)
  elseif (TARGET_ARCH STREQUAL "i386")
    message("-- The official uEye SDK for i386: https://en.ids-imaging.com/download-ueye.html?file=tl_files/downloads/uEye_SDK/driver/uEye_Linux_4.60_32_Bit.zip (~71MB)")
    file(DOWNLOAD 
      #https://bitbucket.org/kmhallen/ueye/downloads/uEye_SDK_4_60_i386.tar.gz
      http://download.ros.org/data/ueye/uEye_SDK_4_60_i386.tar.gz
      ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/uEye_SDK_i386.tar.gz
      SHOW_PROGRESS
      INACTIVITY_TIMEOUT 60
      EXPECTED_MD5 20db4268dd3c0416d289067277fffef7
      TLS_VERIFY on)
    execute_process(
      COMMAND ${CMAKE_COMMAND} -E tar xzf ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/uEye_SDK_i386.tar.gz
      WORKING_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty
    )
    include_directories(${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/i386)
    link_directories(${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/i386)
  elseif (TARGET_ARCH STREQUAL "arm")
    message("-- The official uEye SDK for armhf: https://en.ids-imaging.com/linux-embedded-downloads.html?file=tl_files/downloads/LinuxEmbedded/uEyeSDK-4.60.00-ARM_LINUX_IDS_GNUEABI_HF.tgz (~20MB)")
    message("-- Assuming 'armhf' architecture. The 'armel' build files are available. However, the buildfarm does not build 'armel', and detection at configure time is difficult.")
    file(DOWNLOAD 
      #https://bitbucket.org/kmhallen/ueye/downloads/uEye_SDK_4_60_armhf.tar.gz
      http://download.ros.org/data/ueye/uEye_SDK_4_60_armhf.tar.gz
      ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/uEye_SDK_armhf.tar.gz
      SHOW_PROGRESS
      INACTIVITY_TIMEOUT 60
      EXPECTED_MD5 d8e6cbe59bb19b97bd3d9922ff5ac576
      TLS_VERIFY on)
    execute_process(
      COMMAND ${CMAKE_COMMAND} -E tar xzf ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/uEye_SDK_armhf.tar.gz
      WORKING_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty
    )
    include_directories(${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/armhf)
    link_directories(${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/3rdparty/armhf)
  else ()
    message("-- Warning: Download for '${TARGET_ARCH}' architecture not found.")
  endif ()
endif (NOT HAVE_UEYE_H)

add_library(ueye_nodelets
  src/Camera.cpp
  src/camera_nodelet.cpp src/CameraNode.cpp
  src/stereo_nodelet.cpp src/StereoNode.cpp
  src/framerate_nodelet.cpp src/FramerateNode.cpp
)
add_dependencies(ueye_nodelets ${PROJECT_NAME}_gencfg)
target_link_libraries(ueye_nodelets
  ${catkin_LIBRARIES}
  ueye_api
)

add_executable(camera src/camera_node.cpp)
target_link_libraries(camera
  ueye_nodelets
)

add_executable(stereo src/stereo_node.cpp)
target_link_libraries(stereo
  ueye_nodelets
)

add_executable(framerate src/framerate_node.cpp)
target_link_libraries(framerate
  ueye_nodelets
)

install(TARGETS ueye_nodelets camera stereo framerate
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY launch
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(FILES nodelets.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if (CATKIN_ENABLE_TESTING)

  find_package(roslaunch REQUIRED)
  find_package(rostest REQUIRED)

  # parse check all the launch/*.launch files
  roslaunch_add_file_check(launch)

endif (CATKIN_ENABLE_TESTING)

=== debian/changelog ===
ros-indigo-ueye (0.0.10-0trusty) trusty; urgency=high

  * Updated dependencies
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakland.edu>  Tue, 12 Jul 2016 04:00:00 -0000

ros-indigo-ueye (0.0.9-0trusty) trusty; urgency=high

  * Allow zoom up to 16x
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakland.edu>  Mon, 11 Apr 2016 04:00:00 -0000

ros-indigo-ueye (0.0.8-0trusty) trusty; urgency=high

  * Forgot to remove cv_bridge in package.xml
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakland.edu>  Fri, 04 Dec 2015 05:00:00 -0000

ros-indigo-ueye (0.0.7-0trusty) trusty; urgency=high

  * Fixed frame_id not set properly in stereo node
  * Lock stereo threads with a mutex
  * Inline functions for Camera class getters
  * Removed OpenCV dependency
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakland.edu>  Fri, 04 Dec 2015 05:00:00 -0000

ros-indigo-ueye (0.0.6-0trusty) trusty; urgency=high

  * SDK downloads point to download.ros.org to support the legacy build-farm
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakland.edu>  Wed, 11 Feb 2015 05:00:00 -0000

ros-indigo-ueye (0.0.5-0trusty) trusty; urgency=high

  * Updated amd64, i386, and armhf for uEye SDK 4.60
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakland.edu>  Mon, 09 Feb 2015 05:00:00 -0000

ros-indigo-ueye (0.0.4-0trusty) trusty; urgency=high

  * Allow discrete-only pixelclocks cameras
  * Contributors: Kevin Hallenbeck, Fran Real

 -- Kevin Hallenbeck <kmhallen@oakand.edu>  Wed, 28 Jan 2015 05:00:00 -0000

ros-indigo-ueye (0.0.3-0trusty) trusty; urgency=high

  * Added pre-compiled uEye SDK for arm architecture
  * Fixed macro conversion of version numbers to text. Fixes #8
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <kmhallen@oakand.edu>  Sun, 21 Sep 2014 04:00:00 -0000

ros-indigo-ueye (0.0.2-0trusty) trusty; urgency=high

  * Updated download locations of pre-compiled uEye SDK
  * add camera_id argument to change camera
  * Contributors: Kevin Hallenbeck, Yutaka Kondo <mailto:yutaka.kondo@youtalk.jp>

 -- Kevin Hallenbeck <kmhallen@oakand.edu>  Thu, 18 Sep 2014 04:00:00 -0000

ros-indigo-ueye (0.0.1-0trusty) trusty; urgency=high

  * Initial release into build system.

 -- Kevin Hallenbeck <kmhallen@oakand.edu>  Sun, 14 Sep 2014 04:00:00 -0000

=== debian/control ===
Source: ros-indigo-ueye
Section: misc
Priority: extra
Maintainer: Kevin Hallenbeck <kmhallen@oakland.edu>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-camera-calibration-parsers, ros-indigo-catkin, ros-indigo-dynamic-reconfigure, ros-indigo-image-transport, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-roslaunch, ros-indigo-roslib, ros-indigo-rostest
Homepage: http://wiki.ros.org/ueye
Standards-Version: 3.9.2

Package: ros-indigo-ueye
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-camera-calibration-parsers, ros-indigo-dynamic-reconfigure, ros-indigo-image-transport, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-roslib
Description: Driver for IDS Imaging uEye cameras.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-ueye//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
